const utils = require('../../utils/util')
const app = getApp();
Page({

  data: {
    searchParams: {
      pageNo: 1,
      pageSize: 10,
    },
    list:[],
  },

    /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      list: []
    })
    this.getList()
    setTimeout(() => {
      wx.stopPullDownRefresh()
    }, 300);
  },

  
  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    let that = this;
    //只是测试效果，逻辑以实际数据为准
    this.setData({ 
      loadding: true,
      pullUpOn: true
    })
    this.setData({
      ["searchParams.pageNo"]: that.data.searchParams.pageNo + 1
    })
    this.getList()
  },

  onLoad: function (options) {
      this.getList();
  },
  onReady: function (options) {
  },
 
  searchAgent(){
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      list: []
    })
    this.getList()
  },
  getList() {
    var that = this

    utils.request(utils.api.agentList, that.data.searchParams, "GET", true, false, app.globalData.token).then((res) => {
      if (res.code == 200) {
        if (res.result.records.length > 0) {
          if (that.data.searchParams.pageNo > 0) {
            let list = that.data.list
            res.result.records.forEach((e)=>{
              list.push(e)
            })
            that.setData({
              list: list
            })
          }else{
            that.setData({
              list: res.result.records
            })
          }
        } else {
          that.setData({
            loadding: false,
            pullUpOn: false,
            ["searchParams.pageNo"]:that.data.searchParams.pageNo-1
          })
        }

      }
    }).catch((res) => {})
  },


  toAddAgent(){
    wx.navigateTo({
      url: '/pages/agent/add',
    })
  },
  toDetail(e){
    wx.navigateTo({
      url: '/pages/agent/edit?id='+e.currentTarget.dataset.id,
    })
  },
  inputedit: function (e) {
    let _this = this;
    let dataset = e.currentTarget.dataset;
    let value = e.detail.value;
    let name = dataset.name;
    _this.data[name] = value;
    _this.setData({
      [name]: _this.data[name]
    });
  },
 
})