const util = require('../../utils/util.js');
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    searchParams: {
      pageNo: 1,
      pageSize: 20,
      storeId: ''
    },
    deviceList: [],
    loadding: false,
    pullUpOn: true,

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      ["searchParams.storeId"]: options.storeId
    })
    this.bindDeviceList()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      deviceList: []
    })
    this.bindDeviceList()
    setTimeout(() => {
      wx.stopPullDownRefresh()
    }, 300);
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    //只是测试效果，逻辑以实际数据为准
    this.setData({
      loadding: true,
      pullUpOn: true
    })
    this.setData({
      ["searchParams.pageNo"]: this.data.searchParams.pageNo + 1
    })
    this.bindDeviceList()
  },


  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  toDetail(e) {
    wx.navigateTo({
      url: '/pages/device/detail?deviceId=' + e.currentTarget.dataset.id,
    })
  },
  bindDeviceList() {
    var that = this
    util.request(util.api.deviceListPage, that.data.searchParams, "GET", true, false, app.globalData.token).then((res) => {
      if (res.code == 200) {
        if (res.result.records.length > 0) {
          if (that.data.deviceList.length > 0) {
            let list = that.data.deviceList
            res.result.records.forEach((e)=>{
              list.push(e)
            })
            that.setData({
              deviceList: list
            })
          } else {
            that.setData({
              deviceList: res.result.records
            })
          }
        } else {
          that.setData({
            loadding: false,
            pullUpOn: false
          })
        }
      }
    }).catch((res) => {})
  }
})