const util = require('../../utils/util')
const app = getApp()
const form = require('../../utils/formValidation')
Page({

  /**
   * 页面的初始数据
   */
  data: {
    oneSelect:1,
    productInfo: {},
    productId: '',
    isEdit: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options && options.productId) { 
      this.setData({
        productId: options.productId
      })
      this.bindProduct()
    }
    if (options && options.id) {
      this.setData({
        ["productInfo.id"]: options.id,
        isEdit: true
      })
      this.bindVmProduct()
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  formSubmit: function (e) {
    var that = this
    //表单规则
    let rules = [{
      name: "productPrice",
      rule: ["required", "isAmount"],
      msg: ["请输入金额", "请输入正确的金额，允许保留两位小数"]
    }, {
      name: "productSellPrice",
      rule: ["required", "isAmount"],
      msg: ["请输入金额", "请输入正确的金额，允许保留两位小数"]
    }];

    
    //进行表单检查
    let formData = e.detail.value;
    console.log(e.detail.value)
    let checkRes = form.validation(formData, rules);
    if (!checkRes) {
      if (!that.data.isEdit) {
        that.setData({
          ["productInfo.sysProductId"]: that.data.productInfo.id,
          ["productInfo.id"]: ""
        })

        console.log("==========")
        var productPrice =    e.detail.value.productPrice
        var productSellPrice = e.detail.value.productSellPrice
  
        if(productPrice<=0){
          util.toast("请输入商品进货价")
          return;
        }
        if(productSellPrice<=0){
          util.toast("请输入商品售价")
          return;
        }         
        //js  19.9 * 100有bug
        that.data.productInfo.productPrice = productPrice *10 
        that.data.productInfo.productPrice = that.data.productInfo.productPrice *10
        that.data.productInfo.productSellPrice = productSellPrice *10 
        that.data.productInfo.productSellPrice = that.data.productInfo.productSellPrice * 10
        util.request(util.api.addVmProduct, that.data.productInfo, "POST", false, true, app.globalData.token).then((res) => {
          if (res.code == 200) {
            wx.navigateTo({
              url: '/pages/product/index',
            })
            // wx.navigateBack({
            //   delta: 2
            // })
          }else{
            
            util.toast(res.message)
            setTimeout(()=>{
              wx.navigateTo({
                url: '/pages/product/index',
              })
            },500)
            
          }
        }).catch((res) => {})
      } else {
        util.request(util.api.editVmProduct, that.data.productInfo, "POST", false, true, app.globalData.token).then((res) => {
          if (res.code == 200) {
            wx.navigateBack({
              delta: 1
            })
          }
        }).catch((res) => {})
      }
    } else {
      wx.showToast({
        title: checkRes,
        icon: "none"
      });
    }
  },
  formReset: function (e) {
    console.log("清空数据")
  },
  bindProduct() {
    var that = this
    util.request(util.api.queryByProductId, {
      id: that.data.productId
    }, "GET", true, true, app.globalData.token).then((res) => {
      if (res.code == 200) {
        that.setData({
          productInfo: res.result,
        })
      }
    }).catch((res) => {})
  },
  bindVmProduct() {
    var that = this
    util.request(util.api.queryByVmProductId, {
      id: that.data.productInfo.id
    }, "GET", true, true, app.globalData.token).then((res) => {
      if (res.code == 200) {
        that.setData({
          productInfo: res.result,
        })
      }
    }).catch((res) => {})
  },
  inputedit: function (e) {
    let _this = this;
    let dataset = e.currentTarget.dataset;
    let value = e.detail.value;
    let name = dataset.name;

    value = parseFloat(value) 

    if(!value){
      value = 0.00;
    }

    if (dataset.type && dataset.type == 'float') {
      value = parseInt(parseFloat(value));
      _this.data[name] = value;
    } else {
      _this.data[name] = value;
    }
    _this.setData({
      [name]: _this.data[name]
    });
  }
})