const util = require('../../utils/util')
const app = getApp()
Page({

  /** 
   * 页面的初始数据
   */
  data: {
    searchParams: {
      pageNo: 1,
      pageSize: 10,
      productName: '',
    },
    productList: [],
    loadding: false,
    pullUpOn: true,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.bindProductList()
  },
  onUnload: function () {
    wx.reLaunch({
        url: '../vendingMachine/index',
    })
  },
  
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () { 
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      productList: []
    })
    this.bindProductList()
    setTimeout(() => {
      wx.stopPullDownRefresh()
    }, 300);
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    var that = this
    //只是测试效果，逻辑以实际数据为准
    this.setData({
      loadding: true,
      pullUpOn: true
    })
    this.setData({
      ["searchParams.pageNo"]: that.data.searchParams.pageNo + 1
    })
    this.bindProductList()
  },

  toEdit: function (e) {
    wx.navigateTo({
      url: 'edit?id=' + e.currentTarget.dataset.id
    })
  },
  toAddProduct() {
    wx.navigateTo({
      url: '/pages/product/select',
    })
  },
  deleteProduct(e){
    var id =  e.currentTarget.dataset.id;
    var that = this
    util.request(util.api.deleteMgVmProductById, {'id':id}, "POST", true, true, app.globalData.token).then((res) => {
      console.log(res)
      if(res.code == 200){
        that.setData({
          productList: []
        })
        that.bindProductList();
      }else{
        util.toast(res.message);
      }
      
    }).catch((res) => {})
  },
  bindProductList() {
    var that = this
    util.request(util.api.MgVmProductSkuPage, that.data.searchParams, "GET", false, false, app.globalData.token).then((res) => {
      if (res.code == 200) {
        if (res.result.records.length > 0) {
          if (that.data.productList.length > 0) {
            let list = that.data.productList
            res.result.records.forEach((e)=>{
              list.push(e)
            })
            console.log(list)
            console.log(666)
            that.setData({
              productList: list
            })
          } else {
            that.setData({
              productList: res.result.records
            })
          }
        } else {
          that.setData({
            loadding: false,
            pullUpOn: false,
            ["searchParams.pageNo"]:that.data.searchParams.pageNo-1
          })
        }
      }
    }).catch((res) => {})
  },
  inputedit: function (e) {
    let _this = this;
    let dataset = e.currentTarget.dataset;
    let value = e.detail.value;
    let name = dataset.name;
    _this.data[name] = value;
    _this.setData({
      [name]: _this.data[name]
    });
  },
  btnsearch(){
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      productList: []
    })
    this.bindProductList()
  }
})