// pages/repairs/index.js
const util = require('../../utils/util.js');
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    searchParams:{
      pageNo:1,
      pageSize:10,
    },
    repairList:[],
    loadding: false,
    pullUpOn: true,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.bindRepairList()
  },
  onUnload: function () {
    wx.reLaunch({
        url: '../operation/index',
    })
  },
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      repairList: []
    })
    this.bindRepairList()
    setTimeout(() => {
      wx.stopPullDownRefresh()
    }, 300);
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    var that = this
    //只是测试效果，逻辑以实际数据为准
    this.setData({
      loadding: true,
      pullUpOn: true
    })
    this.setData({
      ["searchParams.pageNo"]: that.data.searchParams.pageNo + 1
    })
    this.bindRepairList()
  },

  toDetailRepairs(e){
    wx.navigateTo({
      url: '/pages/repairs/detail?repairsId='+e.currentTarget.dataset.id,
    })
  },

  toAddRepairs(){
    wx.navigateTo({
      url: 'add',
    })
  },

  bindRepairList(){
    var that = this
    util.request(util.api.repairsListPage, that.data.searchParams, "GET", false, true,app.globalData.token).then((res)=>{
      if (res.code == 200) {
        if (res.result.records.length > 0) {
          if (that.data.repairList.length > 0) {
            let list = that.data.repairList
            var records = res.result.records
            records.forEach(record => {
              list.push(record)
            });
            that.setData({
              repairList: list
            })
          } else {
            that.setData({
              repairList: res.result.records
            })
          }
        } else {
          that.setData({
            loadding: false,
            pullUpOn: false,
            ["searchParams.pageNo"]:that.data.searchParams.pageNo-1
          })
        }
      }
    }).catch((res) => {})
  },
})