const util = require('../../utils/util')
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    searchParams: {
      pageNo: 1,
      pageSize: 10,
      productName: ''
    },
    productList: [],
    loadding: false,
    pullUpOn: true,
    index:0,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let index = parseInt(options.index)
    this.setData({
      index:index
    })
    this.bindProductList()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      storeList: []
    })
    this.bindProductList()
    setTimeout(() => {
      wx.stopPullDownRefresh()
    }, 300);
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    var that = this
    //只是测试效果，逻辑以实际数据为准
    this.setData({
      loadding: true,
      pullUpOn: true
    })
    this.setData({
      ["searchParams.pageNo"]: that.data.searchParams.pageNo + 1
    })
    this.bindProductList()
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  toEdit(e) {
    var row = e.currentTarget.dataset.item;
    var pages = getCurrentPages();
    var prevPage = pages[pages.length - 2];  //上一个页面
    var list = prevPage.data.values.schemeBillEntryList

    var isproduct=list.some(item=>item.productId==row.id);//是否已存在商品
    if(isproduct){
      util.toast('不可选择相同商品')
      return;
    }

    var itemProduct = JSON.parse(JSON.stringify(list))[this.data.index]
    itemProduct.productId = row.id
    itemProduct.productName = row.skuProductName
    itemProduct.productImg = row.productImg
    itemProduct.productSchemePrice = row.productPrice
    itemProduct.storeDivide = 0
    itemProduct.areaDivide = 0
    list.splice(this.data.index,1,itemProduct)
    prevPage.setData({
      ["values.schemeBillEntryList"]:list
    })
    wx.navigateBack()
  },
  bindProductList() {
    var that = this
    util.request(util.api.MgVmProductSkuPage, that.data.searchParams, "GET", false, false, app.globalData.token).then((res) => {
      if (res.code == 200) {
        if (res.result.records.length > 0) {
          if (that.data.productList.length > 0) {
            let list = that.data.productList
            res.result.records.forEach((e)=>{
              list.push(e)
            })
            that.setData({
              productList: list
            })
          } else {
            that.setData({
              productList: res.result.records
            })
          }
        } else {
          that.setData({
            loadding: false,
            pullUpOn: false,
            ["searchParams.pageNo"]:that.data.searchParams.pageNo-1
          })
        }
      }
    }).catch((res) => {})
  },
  inputedit: function (e) {
    let _this = this;
    let dataset = e.currentTarget.dataset;
    let value = e.detail.value;
    let name = dataset.name;
    _this.data[name] = value;
    _this.setData({
      [name]: _this.data[name]
    });
  },
  btnSearch(){
    console.log("1111")
    console.log(this.data.searchParams)
    console.log("2222")
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      productList: []
    })
    this.bindProductList()
  }
})