// pages/store/index.js
const util = require('../../utils/util.js');
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    searchParams:{
      pageNo:1,
      pageSize:20,
      storeName:'',
    },
    storeList:[],
    loadding: false,
    pullUpOn: true,
    
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.bindStoreList()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },
  onUnload: function () {
    wx.reLaunch({
        url: '../index/index',
    })
  },
  
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },



  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      storeList: []
    })
    this.bindStoreList()
    setTimeout(() => {
      wx.stopPullDownRefresh()
    }, 300);
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    var that = this
    //只是测试效果，逻辑以实际数据为准
    this.setData({
      loadding: true,
      pullUpOn: true
    })
    this.setData({
      ["searchParams.pageNo"]: that.data.searchParams.pageNo + 1
    })
    this.bindStoreList()
  },

  onPageScroll(e) {
    this.setData({
      scrollTop: e.scrollTop
    })
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  toAddStore(){
    wx.navigateTo({
      url: '/pages/store/add',
    })
  },
  toDetail(e){
    wx.navigateTo({
      url: '/pages/store/edit?storeId='+e.currentTarget.dataset.id,
    })
  },
  bindStoreList(){
    var that = this
    util.request(util.api.storeListPage, that.data.searchParams, "GET", false, true,app.globalData.token).then((res)=>{
      if (res.code == 200) {
        if (res.result.records.length > 0) {
          if (that.data.storeList.length > 0) {
            let list = that.data.storeList
            var records = res.result.records
            records.forEach(record => {
              list.push(record)
            });

            that.setData({
              storeList: list
            })
          } else {
            that.setData({
              storeList: res.result.records
            })
          }
        } else {
          that.setData({
            loadding: false,
            pullUpOn: false,
            ["searchParams.pageNo"]:that.data.searchParams.pageNo-1
          })
        }
      }
    }).catch((res) => {})
  },
  searchStore(){
    this.setData({
      ["searchParams.pageNo"]: 1,
      pullUpOn: true,
      loadding: false,
      storeList: []
    })
    this.bindStoreList()
  },
  inputedit: function (e) {
    let _this = this;
    let dataset = e.currentTarget.dataset;
    let value = e.detail.value;
    let name = dataset.name;
    _this.data[name] = value;
    _this.setData({
      [name]: _this.data[name]
    });
  },
})